## fractgen 3.0.6

=== CMakeLists.txt ===
# ==========================================================================
# ====                   FRACTAL GRAPHICS GENERATOR                     ====
# ==========================================================================
#
# Copyright (C) 2003-2024 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

CMAKE_MINIMUM_REQUIRED(VERSION 3.16)
PROJECT(fractgen LANGUAGES C CXX)

SET(BUILD_MAJOR "3")
SET(BUILD_MINOR "0")
SET(BUILD_PATCH "6")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})


#############################################################################
#### INSTALLATION_DIRECTORIES                                            ####
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
#### PACKAGING                                                           ####
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES "\\\\.git;\\\\.swp$;~$;\\\\.\\\\#;/\\\\#")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}[_-]")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "\\\\.cmake$|\\\\.make$|\\\\.log$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/CMakeCache\\\\.txt$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/(CMakeFiles|CMakeScripts|_CPack_Packages)/")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/package-version\\\\.h$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/packaging\\\\.conf$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/(po.*/|src.*/|)Makefile$")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


INCLUDE(CheckIncludeFile)
INCLUDE(CheckStructHasMember)


#############################################################################
#### OS-DEPENDENT                                                        ####
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
#### OPTIONS                                                             ####
#############################################################################

OPTION(WITH_QT  "Build the Qt version"           1)
OPTION(WITH_KDE "Build the KDE version"          0)
OPTION(WITH_CLI "Build the command-line version" 1)



#############################################################################
#### REQUIREMENTS                                                        ####
#############################################################################

# ###### Qt #################################################################
SET(CMAKE_AUTOMOC ON)
FIND_PACKAGE(QT NAMES Qt6 COMPONENTS Core Network Widgets Xml PrintSupport)
IF (NOT QT_FOUND)
   FIND_PACKAGE(QT NAMES Qt5 REQUIRED COMPONENTS Core Network Widgets Xml PrintSupport)
ENDIF()
MESSAGE("Using Qt version ${QT_VERSION_MAJOR}!")
FIND_PACKAGE(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Network Widgets Xml PrintSupport)
FIND_PROGRAM(LRELEASE lrelease PATHS /usr/local/lib/qt${QT_VERSION_MAJOR}/bin
                                     /usr/lib64/qt${QT_VERSION_MAJOR}/bin
                                     /usr/lib/qt${QT_VERSION_MAJOR}/bin
                                     /usr/bin
                               REQUIRED)
MESSAGE("Using LRelease ${LRELEASE}!")

# ###### KDE ################################################################
IF (WITH_KDE)
   # Needed:
   # KDE5: libkf5coreaddons-dev libkf5xmlgui-dev
   # KDE6: libkf6coreaddons-dev libkf6xmlgui-dev

   FIND_PACKAGE(ECM "1.0.0" NO_MODULE REQUIRED)
   SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

   INCLUDE(KDEInstallDirs)
   INCLUDE(KDECMakeSettings)
   INCLUDE(KDECompilerSettings NO_POLICY_SCOPE)
   INCLUDE(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)

   FIND_PACKAGE(KF${QT_VERSION_MAJOR} "${QT_VERSION_MAJOR}.0.0" REQUIRED COMPONENTS CoreAddons WidgetsAddons XmlGui)
ENDIF()

INCLUDE(FeatureSummary)
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)


#############################################################################
#### SUBDIRECTORIES                                                      ####
#############################################################################

ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
# ==========================================================================
# ====                   FRACTAL GRAPHICS GENERATOR                     ====
# ==========================================================================
#
# Copyright (C) 2003-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

SET(CMAKE_INCLUDE_CURRENT_DIR ON)


#############################################################################
#### VERSION FILE                                                        ####
#############################################################################

CONFIGURE_FILE (
   "${CMAKE_CURRENT_SOURCE_DIR}/package-version.h.in"
   "${CMAKE_CURRENT_BINARY_DIR}/package-version.h"
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


#############################################################################
#### PROGRAMS                                                            ####
#############################################################################

SET(basicSourceFiles
   classregistry.cc
   colorschemeinterface.cc
   doubleconfigentry.cc
   dreibholz1.cc
   fractalalgorithminterface.cc
   fractalbuffer.cc
   fractalcalculationthread.cc
   fractalgeneratordoc.cc
   fractalgeneratorviewbase.cc
   mandelbrot.cc
   mandelbrotn.cc
   simplehsv.cc
   simplergb.cc
   uintconfigentry.cc
)
SET(guiSourceFiles
   ${basicSourceFiles}
   fractgen.cc
   imagedisplay.cc
   fractalgenerator.cc
   fractalgeneratorview.cc
   optionsdialog.cc
)

# ====== Qt version =========================================================
ADD_EXECUTABLE(fractgen ${guiSourceFiles})
TARGET_LINK_LIBRARIES(fractgen
   Qt${QT_VERSION_MAJOR}::Core
   Qt${QT_VERSION_MAJOR}::PrintSupport
   Qt${QT_VERSION_MAJOR}::Widgets
   Qt${QT_VERSION_MAJOR}::Xml
)

INSTALL(TARGETS             fractgen
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        BUNDLE DESTINATION  ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES fractgen.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

INSTALL(FILES fractgen.png     DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/512x512/apps)
INSTALL(FILES fractgen.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
INSTALL(FILES fractgen.xml     DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/mime/packages)
INSTALL(FILES       fractgen.bash-completion
        DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
        RENAME      fractgen)

FILE(GLOB FRACTGEN_TS_FILES  "fractgen_*.ts")
SET(FRACTGEN_QM_FILES "")
FOREACH(tsFile IN LISTS FRACTGEN_TS_FILES)
   GET_FILENAME_COMPONENT(fileBase ${tsFile} NAME_WE)
   SET(qmFile "${fileBase}.qm")
   ADD_CUSTOM_COMMAND(OUTPUT  ${qmFile}
                      COMMAND ${LRELEASE} -removeidentical ${tsFile})
   ADD_CUSTOM_TARGET(target_${qmFile} ALL DEPENDS ${qmFile})
   LIST(APPEND FRACTGEN_QM_FILES ${qmFile})
ENDFOREACH()
INSTALL(FILES ${FRACTGEN_QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/fractgen)


# ====== KDE version ========================================================
IF (WITH_KDE)
   ADD_EXECUTABLE(kfractgen ${guiSourceFiles})
   SET_TARGET_PROPERTIES(kfractgen PROPERTIES COMPILE_FLAGS "-DWITH_KDE")
   TARGET_LINK_LIBRARIES(kfractgen
      Qt${QT_VERSION_MAJOR}::Core
      Qt${QT_VERSION_MAJOR}::PrintSupport
      Qt${QT_VERSION_MAJOR}::Widgets
      Qt${QT_VERSION_MAJOR}::Xml
      KF${QT_VERSION_MAJOR}::CoreAddons
      KF${QT_VERSION_MAJOR}::WidgetsAddons
      KF${QT_VERSION_MAJOR}::XmlGui
   )
   INSTALL(TARGETS             kfractgen
           RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
           BUNDLE DESTINATION  ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES kfractgen.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES kfractgen.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
   INSTALL(FILES       kfractgen.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      kfractgen)
ENDIF()


# ====== CLI version ========================================================
IF (WITH_CLI)
   ADD_EXECUTABLE(clifractgen
      ${basicSourceFiles}
      clifractgen.cc
   )
   TARGET_LINK_LIBRARIES(clifractgen
      Qt${QT_VERSION_MAJOR}::Core
      Qt${QT_VERSION_MAJOR}::Widgets
      Qt${QT_VERSION_MAJOR}::Xml
   )

   INSTALL(TARGETS             clifractgen
           RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
           BUNDLE DESTINATION  ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES clifractgen.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES       clifractgen.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      clifractgen)
ENDIF()


# ==== Examples =============================================================
FILE(GLOB fractgen_examples "examples/*.fsf")
INSTALL(FILES ${fractgen_examples} DESTINATION ${CMAKE_INSTALL_DATADIR}/fractgen/examples)

=== freebsd/fractgen/Makefile ===
PORTNAME=	fractgen
DISTVERSION=	3.0.6
CATEGORIES=	graphics
MASTER_SITES=	https://www.nntb.no/~dreibh/fractalgenerator/download/

MAINTAINER=	thomas.dreibholz@gmail.com
COMMENT=	Fractal Generator
WWW=		https://www.nntb.no/~dreibh/fractalgenerator/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

USES=		cmake compiler:c++17-lang desktop-file-utils gl qt:6 \
		shared-mime-info tar:xz
USE_GL=		gl opengl
USE_QT=		base tools:build

.include <bsd.port.mk>

=== debian/changelog ===
fractgen (3.0.6-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 3.0.6
  * Add d/gbp.conf
  * Drop myself from uploaders
  * Drop redundant "Rules-Requires-Root: no"
  * Mark fractgen-common and fractgen-examples as M-A: foreign

 -- Nilesh Patra <nilesh@debian.org>  Sat, 18 Oct 2025 21:05:32 +0530

=== debian/control ===
Source: fractgen
Section: graphics
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Thomas Dreibholz <thomas.dreibholz@gmail.com>,
Homepage: https://www.nntb.no/~dreibh/fractalgenerator/
Vcs-Git: https://salsa.debian.org/math-team/fractgen.git
Vcs-Browser: https://salsa.debian.org/math-team/fractgen
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 libkf6coreaddons-dev,
 libkf6xmlgui-dev,
 qt6-base-dev,
 qt6-l10n-tools,
Standards-Version: 4.7.2

Package: fractgen
Architecture: any
Depends:
 fractgen-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fractgen-examples (>= ${source:Version}),
 rsplib-tools,
Description: fractal images calculation application (Qt version)
 FractGen is a simple Qt-based fractal generator program for Mandelbrot
 fractals. The image size is only limited by virtual memory. It is possible
 to zoom into images. Image parameters can be saved in XML files and loaded
 from XML files. Calculated images can be exported as PNG files.
 .
 The intention of this program is to generate graphics to be post-processed
 by other image tools, e.g. in order to generate nice screen backgrounds or
 book covers.
 .
 This is the Qt version of FractGen.

Package: kfractgen
Architecture: any
Depends:
 fractgen-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fractgen-examples (>= ${source:Version}),
 rsplib-tools,
Description: fractal images calculation application (KDE version)
 FractGen is a simple Qt-based fractal generator program for Mandelbrot
 fractals. The image size is only limited by virtual memory. It is possible
 to zoom into images. Image parameters can be saved in XML files and loaded
 from XML files. Calculated images can be exported as PNG files.
 .
 The intention of this program is to generate graphics to be post-processed
 by other image tools, e.g. in order to generate nice screen backgrounds or
 book covers.
 .
 This is the KDE version of FractGen.

Package: clifractgen
Architecture: any
Depends:
 fractgen-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fractgen-examples (>= ${source:Version}),
 rsplib-tools,
Description: fractal images calculation application (command-line version)
 FractGen is a simple Qt-based fractal generator program for Mandelbrot
 fractals. The image size is only limited by virtual memory. It is possible
 to zoom into images. Image parameters can be saved in XML files and loaded
 from XML files. Calculated images can be exported as PNG files.
 .
 The intention of this program is to generate graphics to be post-processed
 by other image tools, e.g. in order to generate nice screen backgrounds or
 book covers.
 .
 This is the command-line version of FractGen.

Package: fractgen-common
Architecture: all
Depends:
 ${misc:Depends},
Breaks: fractgen (<< 3.0.5-1)
Replaces: fractgen (<< 3.0.5-1)
Multi-Arch: foreign
Description: common files for FractGen
 FractGen is a simple Qt-based fractal generator program for Mandelbrot
 fractals. The image size is only limited by virtual memory. It is possible
 to zoom into images. Image parameters can be saved in XML files and loaded
 from XML files. Calculated images can be exported as PNG files.
 .
 The intention of this program is to generate graphics to be post-processed
 by other image tools, e.g. in order to generate nice screen backgrounds or
 book covers.
 .
 This package contains commen files for the Qt, KDE and command-line
 versions of FractGen.

Package: fractgen-examples
Architecture: all
Depends:
 ${misc:Depends},
Breaks: fractgen (<< 3.0.5-1)
Replaces: fractgen (<< 3.0.5-1)
Recommends: fractgen
Multi-Arch: foreign
Description: example files for FractGen
 This package contains some example input files for the fractal generator
 program FractGen. The example files contain the parameters for the
 fractal calculations. FractGen can perform the computations and display
 the resulting images.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_KDE=1

# Use upstream ChangeLog for installation
override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://www.nntb.no/~dreibh/fractalgenerator/index.html	download/fractgen-(.*)\.tar\.xz
